; -------------------------------------
; Calc01
; A PIXIE graphics calculator two 8-bit
; unsigned hex values, entered by the user,
; are multiplied together and the 16-bit
; unsigned hex result are displayed.
;
; The display shows a form:
;  o xx
;    xx
;    xxxx
; with an oval marker drawn to the left of
; the curent value being entered.
;
; When the user presses the [input] key the
; current value keypad value is read, displayed,
; and the marker moved.  After both values are
; entered, they are multiplied, the marker
; removed, and the quotient displayed.  Pressing
; the [input] key then resets the form and the
; program repeats.
;
; ng 2/3/2005
; -------------------------------------
PgView	EQU	2
DgPos1	EQU	#19
DgPos2	EQU	#61
DgPos3	EQU	#A9
DgPos4	EQU	#AB
PgChTb	EQU	1

;
	GHI	R0	; R0 <= 0
	PHI	R1
	PHI	R2
	PHI	R4
	PHI	R5
		
	LDI	Stack
	PLO	R2

	LDI	DmaPrep
	PLO	R1

	LDI	SCall
	PLO	R4

	LDI	SRet
	PLO	R5
						
	LDI	#01
	PHI	R3
	LDI	Start
	PLO	R3

	SEP	R3
		
; ..........................
; SCRT "Call" routine
;
exCall	SEP	R3
SCall	GLO	R6
	STXD
	GHI	R6
	STXD
	GLO	R3
	PLO	R6
	GHI	R3
	PHI	R6
	LDA	R6
	PHI	R3
	LDA	R6
	PLO	R3
	BR 	exCall

; ..........................
; SCRT "Return" routine
;
exRet	SEP R3
SRet	GLO R6
	PLO R3
	GHI R6
	PHI R3
	INC R2
	LDXA
	PHI R6
	LDX
	PLO R6
	BR  exRet

; -------------------------------------------------
; CDP1861, DMA management
; creates a 64x32 display of RAM at 0x0000
;
DmaRet	LDXA
		RET
DmaPrep	DEC	R2
		SAV
		DEC	R2
		STR R2
		NOP
		NOP
		NOP
		LDI PgView
		PHI	R0
		LDI	#0
		PLO	R0
DmaLp	GLO R0
		SEX	R2
		SEX	R2
		DEC	R0
		PLO	R0
		SEX	R2
		DEC	R0
		PLO	R0
		SEX	R2
		DEC	R0
		PLO	R0
		BN1	DmaLp
		BR	DmaRet

; -------------------------------------------------
; Erases the Memory page specified in RF.1
;
MemPgErase	LDI	#00
			PLO	RF
ers01		LDI	#00
			STR	RF
			INC	RF
			GLO RF
			BNZ	ers01
			SEP	R5

; -------------------------------------------------
; Char Draw
;
DrwCh	GLO RF
		STXD
		GHI	RF
		STXD
		
		GLO RE
		SHL
		SHL
		SHL
		ADI	tabCh	; offs of tbl within page
		PLO RE
		LDI PgChTb	; page where table resides
		PHI RE
		LDI #07
		PLO RD
nxRow	LDA RE
		STR RF
		DEC RD
		GLO RF
		ADI #08
		PLO RF
		GLO RD
		BNZ nxRow
		
		INC R2
		LDXA
		PHI	RF
		LDX
		PLO	RF

		SEP R5		; SCRT SRet (return)

; -------------------------------------------------
; Draw digit subr
;
drByte	GLO	R7
		SHR
		SHR
		SHR
		SHR
		ANI	#0F
		PLO	RE
		SEP	R4		; SCRT SCall, DrwCh
		DW	DrwCh
;
		INC	RF
		GLO	R7
		ANI	#0F
		PLO	RE

		SEP	R4		; SCRT SCall, DrwCh
		DW	DrwCh
		
		SEP R5		; SCRT SRet (return)

; -------------------------------------------------
;
getByte		B4	getByte
gbloop		IN4
		OUT4
		DEC	R2
		BN4	gbloop
		SEP	R5
		
; -------------------------------------------------
;
updScrn	LDI	PgView	
		PHI	RF
		SEP	R4
		DW	MemPgErase
		LDI	PgView
		PHI	RF
	
;	......... display 8-bit RA.1
		GHI	RA
		PLO	R7
		LDI	DgPos1
		PLO	RF
		SEP	R4
		DW	drByte
		
;	......... display 8-bit RA.0
		GLO	RA
		PLO	R7
		LDI	DgPos2
		PLO	RF
		SEP	R4
		DW	drByte
		
;	......... display 16-bit R9 
		GHI R9
		PLO	R7
		LDI	DgPos3
		PLO	RF
		SEP	R4
		DW	drByte
		GLO R9
		PLO	R7
		LDI	DgPos4
		PLO	RF
		SEP	R4
		DW	drByte
		
		SEP	R5

;.................. 
drwMrk	DEC	RF	; ... draw marker
		LDI	#10
		PLO	RE
		SEP	R4
		DW	DrwCh
		SEP	R4	; ... wait for value
		DW	getByte
		SEP	R5

;.................. reserve space for stack
;
		DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		DB	0,0,0,0,0,0,0,0,0,0
		DB	0,0,0,0,0,0,0,0,0
Stack	DB	0

;..................
; Start and Char table must begin after 0x0100.
; Zero fill the intervening space
;		
		DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

; -------------------------------------------------
;		
Start	SEX	R2	; set R2 as stack ptr
		IN1		; turn on graphics
		
main2	LDI	#00
		PHI	RA
		PLO	RA
		PHI	R9
		PLO	R9
	
		SEP	R4
		DW	updScrn
	
		LDI	DgPos1	; ... mark input field
		PLO	RF		; and wait for value entry
		SEP	R4
		DW	drwMrk
		IN4
		PHI	RA
	
		SEP	R4		; ... update screen
		DW	updScrn
	
		LDI	DgPos2	; ... mark input field
		PLO	RF		; and wait for value entry
		SEP	R4
		DW	drwMrk
		IN4
		PLO	RA
	
		SEP	R4		; ... update screen
		DW	updScrn
		
;		... multiply the 8-bit values RA.0 and RA.1
;		... and place the result in 16-bit register R9
;		... 
		GHI	RA		; ... preserve RA
		STXD
		GLO	RA
		STXD
		LDI	#00		; R9 <= 0
		PHI	R9
		PLO	R9
		GLO	RA		; if arg is zero we're done
		BZ	nextRnd
multB	GHI	RA		; R9 += RA.1
		STR	R2
		GLO	R9
		ADD
		PLO	R9
		GHI	R9
		ADCI #00
		PHI	R9
		DEC	RA		; dec RA.0
		GLO	RA
		BNZ	multB	; repeat until RA.0 is zero
nextRnd	INC	R2		; ... restore RA
		LDX
		PLO	RA
		INC	R2
		LDX
		PHI	RA
;		... 
;		... 

		SEP	R4		; ... update screen
		DW	updScrn
		SEP	R4		; ... get value
		DW	getByte
		BR	main2
		
;..................
; character bit maps
; 0-F, and a small oval
tabCh	DB #0E,#11,#13,#15,#19,#11,#0E,#00
		DB #04,#0C,#04,#04,#04,#04,#0E,#00
		DB #0E,#11,#01,#06,#08,#10,#1F,#00
		DB #0E,#11,#01,#06,#01,#11,#0E,#00
		DB #02,#06,#0A,#12,#1F,#02,#02,#00
		DB #1F,#10,#1E,#01,#01,#11,#0E,#00
		DB #07,#08,#10,#1E,#11,#11,#0E,#00
		DB #1F,#01,#02,#04,#08,#08,#08,#00
		DB #0E,#11,#11,#0E,#11,#11,#0E,#00
		DB #0E,#11,#11,#0F,#01,#02,#1C,#00
		DB #04,#0A,#11,#11,#1F,#11,#11,#00
		DB #1E,#11,#11,#1E,#11,#11,#1E,#00
		DB #0E,#11,#10,#10,#10,#11,#0E,#00
		DB #1E,#09,#09,#09,#09,#09,#1E,#00
		DB #1F,#10,#10,#1F,#10,#10,#1F,#00
		DB #1F,#10,#10,#1E,#10,#10,#10,#00
		DB #00,#00,#00,#18,#24,#18,#00,#00
